program RENDEZESEK;
uses WinCrt;
const MAX = 100;
var
 VEKTOR :	array [1..MAX] of integer;
 N,I,J,VAL, MENT:	integer;

procedure CSERE(I,J:integer);
begin
  MENT	:=VEKTOR[I];
  VEKTOR[I]	:=VEKTOR[J];
  VEKTOR[J]	:=MENT
end;

{* RENDEZS KIVLASZTSSAL *}
procedure KIVALASZT;
var EMIN : integer;
begin
  I := 1;
  while I <= N-1 do
  begin
    EMIN	:= I;
    J	:= I + 1; while J <= N do
    begin
      if VEKTOR[J] < VEKTOR[EMIN] then
        EMIN := J;
        J :=J  + 1
    end;
    CSERE(EMIN,I);
    I := I + 1
  end
end;

{* SZOMSZDOS ELEMEK CSERJE *}
procedure SZOMSZELEM;
var	VCSERE:	boolean;
	FELSO:	integer;
begin
  VCSERE	:= true;
  FELSO	:= N;
  while VCSERE do
  begin
    VCSERE := false; I := 1; while I < FELSO do
    begin
      if VEKTOR[I + 1] < VEKTOR[I] then
      begin
        VCSERE:=True; CSERE(I,I+1)
      end;
      I := I+1
    end;
    FELSO := FELSO - 1
  end
end;
 {* GYORSRENDEZS (QUICK)*}
 procedure QUICKSORT;
 var VEREM:array [1..MAX,1..2] of byte;
     SZINT,ADAT,
     ALSO,FELSO,INDEX:integer;
 begin
   SZINT        	:= 1;
   VEREM[SZINT,1]	:= 1;
   VEREM[SZINT,2]	:= N;
   repeat
     ALSO	:= VEREM[SZINT,1];
     FELSO	:= VEREM[SZINT,2];
     SZINT	:= SZINT-1;
     repeat
       I	:= ALSO;
       J	:= FELSO;
       INDEX:=Trunc((ALSO + FELSO)/2);
       ADAT	:= VEKTOR[INDEX];
       repeat
         while VEKTOR[I]<ADAT do
           I	:= I + 1;
         while ADAT<VEKTOR[J] do
           J	:= J - 1;
         if I <= J then
         begin
           CSERE(I,J);
           I	:=I + 1;
           J	:=J - 1
         end
       until I>J;
       if I<FELSO then
       begin
         SZINT	:= SZINT + 1;
         VEREM[SZINT,1]	:= I;
         VEREM[SZINT,2]	:= FELSO
       end;
       FELSO	:= J
     until ALSO >= FELSO
   until SZINT = 0
 end;
 begin {* ADATFELVITEL *}
   write('ELEMEK SZMA:');
   readln(N);
   I := 1;
   while I<=N do
   begin
     write(I,'. SZM:');
     readln(VEKTOR[I]);
     I := I + 1
   end;
  {* RENDEZS *}
   if N > 1 then
   begin
   writeln('1.KIVLASZTSOS');
   writeln('2.SZOMSZDOS EL.');
   writeln('3.QUICK SORT');
   readln (VAL);
   case VAL of
   1:KIVALASZT;
   2:SZOMSZELEM;
   3:QUICKSORT
   end
  end;

  {* LISTZS *}
  I:=1;
  while I<=N do
  begin
    writeln(I,'. SZM:',VEKTOR[I]); I:=I + 1
  end
end.
